/**
 * plugin.min.js
 *
 * Released under Attribution-ShareAlike 4.0 International License.
 * Author: Ignacio Gros (http://gros.es/) for http://exelearning.net/
 *
 * License: http://creativecommons.org/licenses/by-sa/4.0/
 */

/**
 * TinyMCE plugin to add content at the end of the body outside a single div.
 * This is a workaround to be able to add content/text after a div element if there's only a single div container. 
 */
tinymce.PluginManager.add('addcontent', function(editor, url) {
	
	editor.addButton('addcontent', {
		tooltip: _("Add a paragraph at the end"),
		image: url + '/img/addcontent.png',
		onclick: function() {
			tinyMCE.activeEditor.dom.add(tinyMCE.activeEditor.getBody(), 'p', {}, '...');
		}
	});
	
	editor.addMenuItem('addcontent', {
		text: _("Add a paragraph at the end"),
		image: url + '/img/addcontent.png',
		context: 'insert',
		onclick: function() {
			tinyMCE.activeEditor.dom.add(tinyMCE.activeEditor.getBody(), 'p', {}, '...');
		}
	});
	
});